using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Dynamicweb;
using Dynamicweb.Frontend;

namespace CustomModules
{
	public partial class Default : System.Web.UI.Page
	{
		protected void Page_Load(object sender, EventArgs e)
		{
			//Set a timer to monitor performance
			long StartTime = DateTime.Now.Ticks;
			//Initiate the pageview object that handles a Page view in Dynamicweb
			Dynamicweb.Frontend.PageView Pageview = new Dynamicweb.Frontend.PageView();

			//Create an instance of the eventhandler object and attach it to the custom module event
			//OBSOLETE START
			//CustomModuleHandler objCustModuleHandler = new CustomModuleHandler();
			//Pageview.Content.CMEventHandler += objCustModuleHandler.GetCustomModule;
			//OBSOLETE END

			//Load data, templates and settings in the pageview object
			Pageview.Load();

			Dynamicweb.Frontend.PageviewControl pvCtrl = new Dynamicweb.Frontend.PageviewControl();
			Output.Controls.Add(pvCtrl);
			pvCtrl.Pageview = Pageview;
			pvCtrl.ParseControls();

			//Output.Text = Pageview.Output();

			//Collect the last performance counter and print if requested
			Pageview.Execution.Add("After output");
			string strDebug = Base.ChkString(Base.Request("Debug"));
			if (strDebug == "True")
			{
				Status.Text = Server.HtmlEncode("<!-- Exe time: " + Convert.ToString((DateTime.Now.Ticks - StartTime) / 10000000 + " " + Pageview.StatusText.ToString() + " -->") + Pageview.Execution.getExecutionTable() + Pageview.OutputPages());
			}
			else
			{
				Status.Text = "<!-- Exe time: " + Convert.ToString((DateTime.Now.Ticks - StartTime) / 10000000) + " " + Pageview.StatusText.ToString() + " -->";
			}
		}
	}

	public class CustomModuleHandler
	{
		public void GetCustomModule(object sender, Dynamicweb.Frontend.CustomModuleEventArgs e)
		{
			string strModuleName = e.Name;
			switch (strModuleName)
			{
				default:
					e.Output = "<font color=\"red\">ERROR!</font> \"" + strModuleName + "\" is an unknown module system name";
					break;
			}
		}
	}
}