﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="AddEditArticle.aspx.cs" Inherits="Dynamicweb.Samples.Web.CustomModules.DvkArticles.Admin.AddEditArticle" ValidateRequest="false" %>
<%@ Register TagPrefix="dw" Namespace="Dynamicweb.Controls" Assembly="Dynamicweb.Controls" %>
<%@ Register Assembly="System.Web.Entity, Version=3.5.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" Namespace="System.Web.UI.WebControls" TagPrefix="asp" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
	<title></title>
	<link rel="Stylesheet" type="text/css" href="/Admin/Stylesheet.css" />
	<style type="text/css">
		.style1
		{
			width: 100%;
		}
	</style>
</head>
<body>
	<form id="form1" runat="server">
	<dw:TabHeader ID="List" Title="Articles" TotalWidth="602" runat="server" Headers="Articles" />
	<div id="Tab1" style="display: block; padding: 4px;" class="tabTable">
		<table class="style1">
		<tr>
			<td>Title</td>
			<td>
				<asp:TextBox ID="ArticleTitle" runat="server" CssClass="std"></asp:TextBox>
			</td>
		</tr>
		<tr>
			<td>Summary</td>
			<td>
				<asp:TextBox ID="Summary" runat="server" TextMode="MultiLine" CssClass="std"></asp:TextBox>
			</td>
		</tr>
		<tr>
			<td>SEO Description</td>
			<td>
				<asp:TextBox ID="SeoDescription" runat="server" TextMode="MultiLine" CssClass="std"></asp:TextBox>
			</td>
		</tr>
		<tr>
			<td>Body</td>
			<td>
				<asp:TextBox ID="Body" runat="server" TextMode="MultiLine" CssClass="std"></asp:TextBox>
			</td>
		</tr>
		<tr>
			<td>Category</td>
			<td>
				<asp:DropDownList ID="CategoryList" runat="server" DataSourceID="EntityDataSource1" DataTextField="Description" DataValueField="Id" CssClass="std">
				</asp:DropDownList>
				<asp:EntityDataSource ID="EntityDataSource1" runat="server" ConnectionString="name=CustomModulesSamplesEntities" DefaultContainerName="CustomModulesSamplesEntities" EntitySetName="Categories" OrderBy="it.[Description]" Select="it.[Id], it.[Description]">
				</asp:EntityDataSource>
			</td>
		</tr>
		<tr>
			<td>Publish from</td>
			<td>
				<dw:DateSelector ID="PublishFrom" runat="server" />
			</td>
		</tr>
		<tr>
			<td>Publish to</td>
			<td>
				<dw:DateSelector ID="PublishTo" runat="server" SetNeverExpire="true" />
			</td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td>
				<asp:Button ID="SaveButton" runat="server" CssClass="buttonSubmit" OnClick="SaveButton_Click" Text="Save" />
			</td>
		</tr>
		</table>
	</div>
	</form>
</body>
</html>
