﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="Dynamicweb.Samples.Web.CustomModules.DvkArticles.Admin.Default" %>
<%@ Register TagPrefix="dw" Namespace="Dynamicweb.Controls" Assembly="Dynamicweb.Controls" %>
<%@ Import Namespace="Dynamicweb" %>
<%@ Import Namespace="Dynamicweb.Backend" %>
<%@ Register Assembly="System.Web.Entity, Version=3.5.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" Namespace="System.Web.UI.WebControls" TagPrefix="asp" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
	<title>Manage articles</title>
	<link rel="Stylesheet" type="text/css" href="/Admin/Stylesheet.css" />
</head>
<body>
	<form id="Form1" method="post" runat="server">
	<dw:TabHeader ID="List" Title="Articles" TotalWidth="602" runat="server" Headers="Articles" />
	<asp:DropDownList ID="TableList" runat="server">
	</asp:DropDownList>
	<div id="Tab1" style="display: block; padding: 4px;" class="tabTable">
		<asp:Repeater ID="ArticleList" runat="server" DataSourceID="EntityDataSource1">
			<HeaderTemplate>
				<table border="0" cellpadding="0" style="width: 600px;">
				<tbody>
					<tr>
						<td style="width: 400px;"><strong>Article</strong> </td>
						<td style="width: 100px;"><strong>Edit</strong> </td>
						<td style="width: 100px;"><strong>Delete</strong> </td>
					</tr>
			</HeaderTemplate>
			<ItemTemplate>
				<tr>
					<td>
						<asp:Literal ID="litTitle" runat="server" Text='<%# Eval("Title") %>' />
					</td>
					<td>
						<asp:HyperLink ID="lnkEdit" runat="server" NavigateUrl='<%# "AddEditArticle.aspx?Id=" + DataBinder.Eval(Container.DataItem, "Id") %>'>Edit</asp:HyperLink>
					</td>
					<td>
						<asp:HyperLink ID="lnkDelete" runat="server" NavigateUrl='<%# "DeleteArticle.aspx?Id=" + DataBinder.Eval(Container.DataItem, "Id") %>'>Delete</asp:HyperLink>
					</td>
				</tr>
			</ItemTemplate>
			<FooterTemplate>
				</tbody> </table>
			</FooterTemplate>
		</asp:Repeater>
		<asp:EntityDataSource ID="EntityDataSource1" runat="server" ConnectionString="name=CustomModulesSamplesEntities" DefaultContainerName="CustomModulesSamplesEntities" Where="it.Deleted == false" EntitySetName="Articles" Select="it.[Id], it.[Title]">
		</asp:EntityDataSource>
		<br />
		<br />
		<a href="AddEditArticle.aspx">New Article</a>
	</div>
	</form>
</body>
</html>
