/****** Object:  Table [dbo].[DvkArticle]    Script Date: 07/22/2010 13:18:40 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [dbo].[DvkArticle](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[Title] [varchar](150) NOT NULL,
	[Summary] [varchar](4648) NOT NULL,
	[SeoDescription] [nvarchar](1000) NULL,
	[Body] [text] NOT NULL,
	[CategoryId] [int] NOT NULL,
	[PublicationDateFrom] [datetime] NOT NULL,
	[PublicationDateTo] [datetime] NOT NULL,
	[CreateDateTime] [datetime] NOT NULL,
	[UpdateDateTime] [datetime] NOT NULL,
	[Deleted] [bit] NOT NULL
 CONSTRAINT [PK_DvkArticle] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO
/****** Object:  Table [dbo].[DvkCategory]    Script Date: 07/22/2010 13:18:40 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[DvkCategory](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[Description] [nvarchar](100) NOT NULL,
	[SortOrder] [int] NOT NULL,
 CONSTRAINT [PK_DvkCategory] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Default [DF_DvkCategory_SortOrder]    Script Date: 07/22/2010 13:18:40 ******/
ALTER TABLE [dbo].[DvkCategory] ADD  CONSTRAINT [DF_DvkCategory_SortOrder]  DEFAULT ((0)) FOR [SortOrder]
GO
/****** Object:  Default [DF_DvkArticle_CreateDateTime]    Script Date: 07/22/2010 13:18:40 ******/
ALTER TABLE [dbo].[DvkArticle] ADD  CONSTRAINT [DF_DvkArticle_CreateDateTime]  DEFAULT (getdate()) FOR [CreateDateTime]
GO
/****** Object:  Default [DF_DvkArticle_UpdateDateTime]    Script Date: 07/22/2010 13:18:40 ******/
ALTER TABLE [dbo].[DvkArticle] ADD  CONSTRAINT [DF_DvkArticle_UpdateDateTime]  DEFAULT (getdate()) FOR [UpdateDateTime]
GO
/****** Object:  Default [DF_DvkArticle_Deleted]    Script Date: 07/22/2010 13:18:40 ******/
ALTER TABLE [dbo].[DvkArticle] ADD  CONSTRAINT [DF_DvkArticle_Deleted]  DEFAULT ((0)) FOR [Deleted]
GO
/****** Object:  Default [DF_DvkArticle_PublicationDateFrom]    Script Date: 07/22/2010 13:18:40 ******/
ALTER TABLE [dbo].[DvkArticle] ADD  CONSTRAINT [DF_DvkArticle_PublicationDateFrom]  DEFAULT (getdate()) FOR [PublicationDateFrom]
GO
/****** Object:  Default [DF_DvkArticle_PublicationDateTo]    Script Date: 07/22/2010 13:18:40 ******/
ALTER TABLE [dbo].[DvkArticle] ADD  CONSTRAINT [DF_DvkArticle_PublicationDateTo]  DEFAULT (getdate()) FOR [PublicationDateTo]
GO
